<?php
/**
 * @version 1.0 $Id: com_quickfaq.php 137 2008-08-04 20:57:18Z schlu $
 * @package Joomla
 * @subpackage QuickFAQ sh404sef plugin
 * @copyright (C) 2005 - 2008 Christoph Lukes
 * @license GNU/GPL, see LICENSE.php
 * QuickFAQ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * QuickFAQ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with QuickFAQ; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

// ------------------  standard plugin initialize function - don't change ---------------------------


global $sh_LANG, $sefConfig;

$shLangName = '';
$shLangIso = '';
$title = array ( );
$shItemidString = '';
$dosef = shInitializePlugin ( $lang, $shLangName, $shLangIso, $option );

if ($dosef == false) {
	return;
}

// ------------------  /standard plugin initialize function - don't change ---------------------------


// ------------------  load language file - adjust as needed ----------------------------------------


$shLangIso = shLoadPluginLanguage ( 'com_quickfaq', $shLangIso, '_SH404SEF_QUICKFAQ_ADD' );

// ------------------  /load language file - adjust as needed ----------------------------------------


$view = isset ( $view ) ? @$view : null;
$Itemid = isset ( $Itemid ) ? @$Itemid : null;
$shFAQName = shGetComponentPrefix ( $option );
$shFAQName = empty ( $shFAQName ) ? 

getMenuTitle ( $option, $view, $Itemid, null, $shLangName ) : $shFAQName;

$shFAQName = (empty ( $shFAQName ) || $shFAQName == '/') ? 'FAQ' : $shFAQName;

if (! empty ( $shFAQName )) {
	$title [] = $shFAQName;
}

switch ( $view) {
	
	case 'items' :
		
		isset ( $task ) ? $task : $task = '';
		
		if (! empty ( $id ) && ! empty ( $cid )) {
			
			$query = 'SELECT i.id, i.title, c.title AS cattitle' . ' FROM #__quickfaq_items AS i' . ' LEFT JOIN #__quickfaq_cats_item_relations AS rel ON rel.itemid = i.id' . ' LEFT JOIN #__quickfaq_categories AS c ON c.id = rel.catid' . ' WHERE i.id = ' . ( int ) $id;
			$database->setQuery ( $query );
			
			if (shTranslateURL ( $option, $shLangName )) {
				$row = $database->loadObject ();
			} else {
				$row = $database->loadObject ( null, false );
			}
			
			if ($database->getErrorNum ()) {
				die ( $database->stderr () );
			} elseif ($row) {
				if ($row->title) {
					$title [] = $row->cattitle;
					$title [] = $row->title;
					if ($task == 'edit') {
						$title [] = $sh_LANG [$shLangIso] ['_SH404SEF_QUICKFAQ_EDIT'];
						shRemoveFromGETVarsList ( 'task' );
					}
				}
			}
			shRemoveFromGETVarsList ( 'id' );
			shRemoveFromGETVarsList ( 'cid' );
		} else {
			if ($task == 'add') {
				$title [] = $sh_LANG [$shLangIso] ['_SH404SEF_QUICKFAQ_ADD'];
				shRemoveFromGETVarsList ( 'task' );
			} else {
				$title [] = '/';
			}
		}
	break;
	
	case 'category' :
		if (! empty ( $cid )) {
			$query = 'SELECT id, title FROM #__quickfaq_categories WHERE id = ' . ( int ) $cid;
			$database->setQuery ( $query );
			
			if (shTranslateURL ( $option, $shLangName )) {
				$row = $database->loadObject ();
			} else {
				$row = $database->loadObject ( null, false );
			}
			
			if ($database->getErrorNum ()) {
				die ( $database->stderr () );
			} elseif ($row) {
				if ($row->title) {
					$title [] = $row->title;
				}
			}
			shRemoveFromGETVarsList ( 'cid' );
		} else {
			$title [] = '/';
		}
	break;
	
	case 'tags' :
		if (! empty ( $id )) {
			$query = 'SELECT id, name FROM #__quickfaq_tags WHERE id = ' . ( int ) $id;
			$database->setQuery ( $query );
			
			if (shTranslateURL ( $option, $shLangName )) {
				$row = $database->loadObject ();
			} else {
				$row = $database->loadObject ( null, false );
			}
			
			if ($database->getErrorNum ()) {
				die ( $database->stderr () );
			} elseif ($row) {
				if ($row->name) {
					$title [] = $row->name;
				}
			}
			shRemoveFromGETVarsList ( 'id' );
		} else {
			$title [] = '/';
		}
	break;
	
	case 'favourites' :
		$title [] = $sh_LANG [$shLangIso] ['_SH404SEF_QUICKFAQ_FAVOURITES'] . $sefConfig->suffix;
	break;
	
	case 'quickfaq' :
		$title [] = $sh_LANG [$shLangIso] ['_SH404SEF_QUICKFAQ'] . $sefConfig->suffix;
	break;
	
	default :
		$title [] = '/';
	break;
}

shRemoveFromGETVarsList ( 'option' );
shRemoveFromGETVarsList ( 'lang' );

if (! empty ( $Itemid ))
	shRemoveFromGETVarsList ( 'Itemid' );

if (! empty ( $limit ))
	shRemoveFromGETVarsList ( 'limit' );

if (isset ( $limitstart ))
	shRemoveFromGETVarsList ( 'limitstart' ); // limitstart can be zero


if (! empty ( $view ))
	shRemoveFromGETVarsList ( 'view' );
	
// ------------------  standard plugin finalize function - don't change ---------------------------  


if ($dosef) {
	$string = shFinalizePlugin ( $string, $title, $shAppendString, $shItemidString, (isset ( $limit ) ? @$limit : null), (isset ( $limitstart ) ? @$limitstart : null), (isset ( $shLangName ) ? @$shLangName : null) );
}

// ------------------  /standard plugin finalize function - don't change ---------------------------
?>