<?php

	class Reader extends Controller
	{

		function Reader()
		{
			parent::Controller();
			$this->load->helper('url');	
		}

		function index()
		{
			$this->load->view('loading');
		}

		function readUpdates()
		{
			//define return values
			$feed = $description = array();

			$this->config->load('feeds', true);

			$feedUrl = $this->config->item('updates', 'feeds');

			try {
				//get the feed if exists
				$rawFeed = @file_get_contents($feedUrl);

				//parse the feed into xml if in correct format
				$xml = @new SimpleXmlElement($rawFeed);

				//organize the feeds
				$id = 0;
				foreach ($xml->channel->item as $i) {

					$feed[$id] = "<a href=\"#\" rel=\"$id\">{$i->title}</a>";
					$description[$id++] = "<h6>Priority: $i->category</h6>{$i->description[0]}<a href=\"{$i->link}\" target=\"_blank\" class=\"readmore\">View More Details</a>";

				}

			}
			catch (exception $e) {
				//continue
			}


			$data['feed'] = $feed;
			$data['desc'] = "'" . implode('\',\'', $description) . "'";


			$this->load->view('updates_rss', $data);


		}

		function feedMashup()
		{
			//define return values
			$feed = $description = array();

			$this->config->load('feeds', true);

			$id = 0;

			//build image name array
			$imgname = array('services' => 'lightning.png', 'updates' => 'error.png', 'clinics' => 'badge.png');

			foreach ($this->config->config['feeds'] as $fcategory => $feedUrl) {
				
				try {
					$rawFeed = @file_get_contents($feedUrl);


					$xml = @new SimpleXmlElement($rawFeed);

					//organize the feeds

					foreach ($xml->channel->item as $i) {

						$img = '<img src="assets/images/' . $imgname[$fcategory] . '" width="16" height="16" border="0" />';

						$feed[$id] = "<a name=\"$id\" rel=\"$id\">$img {$i->title}</a>";
						$description[$id++] = "<h6>Category: {$i->category}</h6>{$i->description[0]}... <a href=\"{$i->link}\" target=\"_blank\" class=\"readmore\">View More Details</a>";

					}
				}
				catch (exception $e) {
    				//continue
				}


			}

			$data['feed'] = $feed;
			$data['desc'] = "'" . implode('\',\'', $description) . "'";

			$this->load->view('mashup_rss', $data);


		}
	}

	/* End of file welcome.php */
	/* Location: ./system/application/controllers/welcome.php */
