<?php
/**
 * @version 1.0 $Id: helper.php 152 2008-08-09 13:11:39Z schlu $
 * @package Joomla
 * @subpackage QuickFAQ Tag Cloud Module
 * @copyright (C) 2005 - 2008 Christoph Lukes
 * @license GNU/GPL, see LICENSE.php
 * QuickFAQ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * QuickFAQ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with QuickFAQ; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_quickfaq'.DS.'helpers'.DS.'route.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_quickfaq'.DS.'classes'.DS.'quickfaq.acl.php');

class modQFTagCloudHelper
{
	function getTags(&$params)
	{
		global $mainframe;

		$db			= & JFactory::getDBO();
		$user		= & JFactory::getUser();
		$gid		= (int) $user->get('aid');

		//only select items assigned to category the user has access to
		$states = '1, -4';
		if ($user->authorize('com_quickfaq', 'state')) {
			$states .= ', 0 , -2, -3';
		}
		$where = ' WHERE i.state IN ('.$states.')';
		$where .= ' AND c.access <= '.$gid;
		$where .= ' AND c.published = 1';
		
		$minsize 	= (int)$params->get('min_size', '1');
		$maxsize 	= (int)$params->get('max_size', '10');
		$limit 		= (int)$params->get('limit', '25');

		//Count Tags
		$query = 'SELECT COUNT( t.tid ) AS no'
				. ' FROM #__quickfaq_tags_item_relations AS t'
				. ' LEFT JOIN #__quickfaq_items AS i ON i.id = t.itemid'
				. ' LEFT JOIN #__quickfaq_cats_item_relations AS rel ON rel.itemid = i.id'
				. ' LEFT JOIN #__quickfaq_categories AS c ON c.id = rel.catid'
				. $where
				. ' GROUP BY t.tid'
				. ' ORDER BY no DESC'
				;
		
		$db->setQuery($query, 0, $limit);
		$result = $db->loadResultArray();
		
		$max = (int)$result[0];
		$min = (int)$result[sizeof($result)-1];
		
		$query = 'SELECT t.id, t.name, count( rel.tid ) AS no,'
				. ' CASE WHEN CHAR_LENGTH(t.alias) THEN CONCAT_WS(\':\', t.id, t.alias) ELSE t.id END as slug'
				. ' FROM #__quickfaq_tags AS t'
				. ' LEFT JOIN #__quickfaq_tags_item_relations AS rel ON rel.tid = t.id'
				. ' LEFT JOIN #__quickfaq_items AS i ON i.id = rel.itemid'
				. ' LEFT JOIN #__quickfaq_cats_item_relations AS rel2 ON rel2.itemid = i.id'
				. ' LEFT JOIN #__quickfaq_categories AS c ON c.id = rel2.catid'
				. $where
				. ' GROUP BY t.id'
				. ' HAVING no >= '. $min
				. ' ORDER BY t.name'
				;
		
		$db->setQuery($query, 0, $limit);
		$rows = $db->loadObjectList();

		$i		= 0;
		$lists	= array();
		foreach ( $rows as $row )
		{	
			$lists[$i]->size 			= modQFTagCloudHelper::sizer($min, $max, $row->no, $minsize, $maxsize);
			$lists[$i]->name 			= $row->name;
			$lists[$i]->screenreader	= JText::sprintf('NR ITEMS TAGGED', $row->no);
			$lists[$i]->link 			= JRoute::_(QuickfaqHelperRoute::getTagRoute($row->slug));
			$i++;
		}

		return $lists;
	}
	
	/**
	 * sort the tags between a range from 1 to 10 according their use
	 */
	function sizer($min, $max, $no, $minsize, $maxsize)
	{		
		$spread = $max - $min;
		if (0 == $spread) {
	   		$spread = 1;
		}

		$step = ($maxsize - $minsize) / $spread;

    	$size = $minsize + (($no - $min) * $step);
		$size = ceil($size);
		
		return $size;
	}
}
?>